defmodule Dp.Case do
  # @author "hanak@emt.bme.hu"
  # @date "$LastChangedDate: 2013-11-03 11:45:36 +0100 (v, 03 nov 2013) $$"

  @type asciicode :: integer
  @spec to_decval(hexval::asciicode) :: d::integer
  #
  def to_decval(hexval) do
    case hexval do
      hv when ?0 <= hv and hv <= ?9
	 -> hv - ?0
      ?a -> 10
      ?b -> 11
      ?c -> 12
      ?d -> 13
      ?e -> 14
      ?f -> 15
      _  -> nil
    end
  end

  @spec to_decval_1(hexval::asciicode) :: d::integer
  #
  def to_decval_1(hexval) do
    case hexval do
      _ when ?0 <= hexval and hexval <= ?9 ->
	hexval - ?0
      _ when ?a <= hexval and hexval <= ?f ->
	hexval - ?a + 10
      _ ->
	nil
    end
  end
  
  def test(0) do
    IO.inspect to_decval(?f)
    IO.inspect to_decval(?6)
    IO.inspect to_decval(?z)
  end
  
  def test(1) do
    IO.inspect to_decval_1(?c)
    IO.inspect to_decval_1(?3)
    IO.inspect to_decval_1(?Z)
  end
  
end

Dp.Case.test(0)
IO.puts ""
Dp.Case.test(1)
