# @author "hanak@emt.bme.hu"
# @date "$LastChangedDate: 2013-11-03 11:45:36 +0100 (v, 03 nov 2013) $$"

# @type asciicode :: integer
# @spec to_decval(hexval::asciicode) :: d::integer
#
to_decval = fn (hexval) ->
  cond do
    ?0 <= hexval && hexval <= ?9 -> hexval - ?0
    ?a <= hexval and hexval <= ?f -> hexval - ?a + 10
  end
end

to_decval_2 = fn (hexval) ->
  cond do
    ?0 <= hexval and hexval <= ?9 -> hexval - ?0
    ?a <= hexval and hexval <= ?f -> hexval - ?a + 10
    true                         -> nil
  end
end

to_decval_3 = fn (hexval) ->
  cond do
    ?0 <= hexval && hexval <= ?9 -> {:ok, hexval - ?0}
    ?a <= hexval && hexval <= ?f -> {:ok, hexval - ?a + 10}
    true                         -> :error
  end
end

IO.inspect to_decval.(?f)
IO.inspect to_decval_2.(0)
IO.inspect to_decval_3.(?z)
